from typing import Callable, Self, Type
from .style import Style


class ColorMeta(type):
    def __new__(cls: Type[Self], name: str, bases: tuple, dct: dict) -> Type[Self]: ...

    @staticmethod
    def _setup(cls: ColorMeta) -> None: ...
    @staticmethod
    def _gen_method(attr: str) -> Callable[[str], Style]: ...


class Color:
    def __new__(cls: Type[Self], text: str) -> Style: ...

    @staticmethod
    def extend(style: Style) -> Style: ...
    @staticmethod
    def clean(style: Style) -> Style: ...

    # styles

    @staticmethod
    def bold(text: str) -> Style: ...
    @staticmethod
    def dim(text: str) -> Style: ...
    @staticmethod
    def italic(text: str) -> Style: ...
    @staticmethod
    def underline(text: str) -> Style: ...
    @staticmethod
    def through(text: str) -> Style: ...
    @staticmethod
    def reverse(text: str) -> Style: ...
    @staticmethod
    def blink(text: str) -> Style: ...
    @staticmethod
    def blink_fast(text: str) -> Style: ...
    @staticmethod
    def hidden(text: str) -> Style: ...

    # fg

    @staticmethod
    def black(text: str) -> Style: ...
    @staticmethod
    def red(text: str) -> Style: ...
    @staticmethod
    def green(text: str) -> Style: ...
    @staticmethod
    def yellow(text: str) -> Style: ...
    @staticmethod
    def blue(text: str) -> Style: ...
    @staticmethod
    def magenta(text: str) -> Style: ...
    @staticmethod
    def cyan(text: str) -> Style: ...
    @staticmethod
    def white(text: str) -> Style: ...
    @staticmethod
    def bright_black(text: str) -> Style: ...
    @staticmethod
    def bright_red(text: str) -> Style: ...
    @staticmethod
    def bright_green(text: str) -> Style: ...
    @staticmethod
    def bright_yellow(text: str) -> Style: ...
    @staticmethod
    def bright_blue(text: str) -> Style: ...
    @staticmethod
    def bright_magenta(text: str) -> Style: ...
    @staticmethod
    def bright_cyan(text: str) -> Style: ...
    @staticmethod
    def bright_white(text: str) -> Style: ...

    # bg

    @staticmethod
    def bg_black(text: str) -> Style: ...
    @staticmethod
    def bg_red(text: str) -> Style: ...
    @staticmethod
    def bg_green(text: str) -> Style: ...
    @staticmethod
    def bg_yellow(text: str) -> Style: ...
    @staticmethod
    def bg_blue(text: str) -> Style: ...
    @staticmethod
    def bg_magenta(text: str) -> Style: ...
    @staticmethod
    def bg_cyan(text: str) -> Style: ...
    @staticmethod
    def bg_white(text: str) -> Style: ...
    @staticmethod
    def bg_bright_black(text: str) -> Style: ...
    @staticmethod
    def bg_bright_red(text: str) -> Style: ...
    @staticmethod
    def bg_bright_green(text: str) -> Style: ...
    @staticmethod
    def bg_bright_yellow(text: str) -> Style: ...
    @staticmethod
    def bg_bright_blue(text: str) -> Style: ...
    @staticmethod
    def bg_bright_magenta(text: str) -> Style: ...
    @staticmethod
    def bg_bright_cyan(text: str) -> Style: ...
    @staticmethod
    def bg_bright_white(text: str) -> Style: ...
